from rocolib.api.components.Component import Component

c = Component()

c.addSubcomponent("front", "NewBrainsTwoWheels")
c.addSubcomponent("back", "TwoWheels")

c.addParameter("length", 65, paramType="length", minValue=65) #tested minValue
c.addParameter("height", 36, paramType="length", minValue=36) #tested minValue
c.addParameter("width", 60, paramType="length", minValue=60) #tested minValue

c.addConstraint(("front", "length"), "length")
c.addConstraint(("front", "height"), "height")
c.addConstraint(("front", "width"), "width")

c.addConstraint(("back", "length"), "length")
c.addConstraint(("back", "height"), "height")
c.addConstraint(("back", "width"), "width")

#Main component of steering wheel car which makes them moveable: trapezoid that connects the two half of the car
for i in range(4):
    c.addSubcomponent("midsupport%d" %i, "Trapezoid")
    c.addConstraint(("midsupport%d" %i, "width"), "width", "x-10")
    c.addConstraint(("midsupport%d" %i, "depth"), "width", "x-37")
    c.addConstraint(("midsupport%d" %i, "bangle"), "width",
                    "float(np.atan((x-37)/5)* 180 * 0.318309)")

c.addConnection(("back", "sheath1.botedge2"), ("midsupport1", "botedge"))
c.addConnection(("front", "sheath0.botedge2"), ("midsupport0", "botedge"))
c.addConnection(("back", "sheath1.botedge0"), ("midsupport2", "botedge"))
c.addConnection(("front","sheath0.botedge0"), ("midsupport3", "botedge"))

c.addConnection(("midsupport0", "topedge"), ("midsupport1", "topedge"))

c.toLibrary("CarForSteering")
