from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("boat", "BoatWithStackBattery", inherit=True)
c.inheritAllInterfaces("boat")

# c.addParameter("length", 130, paramType="length")
# c.addParameter("width", 90, paramType="length")
# c.addParameter("depth", 70, paramType="length")
#
c.addConstConstraint(("boat", "toplength"), 102)
c.addConstConstraint(("boat", "botlength"), 102)
# c.addConstraint(("boat", "boat.depth"), "depth")

#Servo Mounts
for i in range(2):
    c.addSubcomponent("servoMount%d" %i, "DoubleServoMount", inherit=("armwidth", "armdepth"))
    c.addConstraint(("servoMount%d" %i, "armwidth"), "boat.width")
    c.addConstraint(("servoMount%d" %i, "armdepth"), "boat.depth")

#Split Edges
for i in range(4):
    c.addSubcomponent("split%d" %i, "SplitEdge")
    c.addConstConstraint(("split%d" %i, "toplength"), (102,)) #78 + 24
    if i % 2 != 0:
        c.addConstConstraint(("split%d" %i, "botlength"), (78, 24)) #symmetric
    else:
        c.addConstConstraint(("split%d" %i, "botlength"), (24, 78)) #symmetric

#connections to each of the DC mounts
c.addConnection(("servoMount0", "lServoInterface"), ("split0", "botedge0"))
c.addConnection(("servoMount0", "rServoInterface"), ("split1", "botedge1"))

c.addConnection(("servoMount1", "lServoInterface"), ("split2", "botedge0"))
c.addConnection(("servoMount1", "rServoInterface"), ("split3", "botedge1"))
#
# c.addConnection(("servoMount2", "lServoInterface"), ("split2", "botedge1"), tabWidth=6)
# c.addConnection(("servoMount2", "rServoInterface"), ("split3", "botedge1"))
#
# c.addConnection(("servoMount3", "lServoInterface"), ("split2", "botedge4"), tabWidth=6)
# c.addConnection(("servoMount3", "rServoInterface"), ("split3", "botedge4"))

# c.addConnection(("split0", "botedge2"), ("servoMount%d" %i, "rightArmInterface"))
# c.addConstraint(("split0", "botlength"), ("topDistance", "botDistance"), "(x[0]-5, 10, x[1]-5)")
# c.addConstraint(("split1", "botlength"), ("topDistance", "botDistance"), "(x[1]-5, 10, x[0]-5)")
#
c.addConnection(("boat", "porttopsplit"), ("split0", "topedge0"))
c.addConnection(("boat", "portbotsplit"), ("split2", "topedge0"))
c.addConnection(("boat", "startopsplit"), ("split1", "topedge0"))
c.addConnection(("boat", "starbotsplit"), ("split3", "topedge0"))
#
# c.addConnection(("servoMount","rightArmInterface"), ("split0", "botedge1"), angle=-180)
# c.addConnection(("servoMount","leftArmInterface"), ("split1", "botedge1"), tabWidth=5, angle=-180)

c.toLibrary("BoatWithManyServoMounts")
